
/*  A Bison parser, made from SelectParser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PLUS	257
#define	MINUS	258
#define	MULT	259
#define	DIV	260
#define	EXPO	261
#define	MODULO	262
#define	ANDIF	263
#define	ORIF	264
#define	NOT	265
#define	GTI	266
#define	MASK	267
#define	REGION	268
#define	IN	269
#define	AND	270
#define	OR	271
#define	XOR	272
#define	LSHIFT	273
#define	RSHIFT	274
#define	BITCOMPL	275
#define	TRUECONST	276
#define	FALSECONST	277
#define	POLYGONFUNC	278
#define	POLYGONFUNC2	279
#define	VECTOR	280
#define	SKY	281
#define	UNIT	282
#define	CROSSPROD	283
#define	CONE	284
#define	NORM	285
#define	LT	286
#define	LE	287
#define	GT	288
#define	GE	289
#define	EQ	290
#define	NE	291
#define	AFUNC	292
#define	AFUNC2	293
#define	SFUNC	294
#define	ASFUNC	295
#define	SPATFUNC4	296
#define	SPATFUNC5	297
#define	SPATFUNC6	298
#define	SPATFUNC7	299
#define	SPATFUNC10	300
#define	NEAR	301
#define	IFTHENELSE	302
#define	BIDENT	303
#define	IIDENT	304
#define	RIDENT	305
#define	SIDENT	306
#define	NLITERAL	307
#define	SLITERAL	308
#define	ISNULL	309
#define	SELECTED	310
#define	FILENAME	311
/* AI gcc4 porting
 * free not found
 */
#include <cstdlib>
#include <cstdio>
#line 1 "SelectParser.y"

//---------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                   (c) 1997-2010 European Space Agency
//
//---------------------------------------------------------------------------
//
//	SelectParser.y --- grammar for selection library
//
//	DESCRIPTION:
//		This is a yacc/bison input file which defines the grammar of
//		boolean expressions to be used by the event selection tasks in the SAS
//
//	CHANGE HISTORY:
//		UL, 1997-12-17: 1.0.0: - first version
//		UL, 1998-04-06: 1.1.0: - various new features addded
//		UL, 1998-04-09: 1.2.0: - ifthenelse added
//		UL, 1998-05-19: 2.0.0: - made it more C++'ish
//							   - have no a start symbol which reduces to
//								 either a logic or arithmetic expression
//		UL, 1998-06-18: 2.1.0: - added 'IN' operator for
//									o intervals, e.g. "PHA in 0.1,10"
//									o regions, e.g. (10,10) in circle(10,10,3)
//									o file-based filters, e.g.,
//										"10.1 in gti(gti.fits)"
//							   - for the file-based filters, blocks can now
//								 be specified by name as well as number, e.g.
//									gti.fits[GTI10]  or   gti.fits[12]
//							   - new boolean function "SELECTED"; gets
//								 expanded into conventional constructs in the
//								 lexer
//		UL, 1999-11-17: 2.2.0: - updates to avoid name clashes at the linking
//								 stage with more than one lexer/parser in the
//								 system:
//									o call the lexer with a special name
//									o wrap the parser in a namespace
//		UL, 2000-05-29: 2.3.0: - fixed bug in mask filter which caused
//									mask(m.ds, xOff, yOff, xCol, yCol)
//								 and
//									(xCol, yCol) in mask(m.ds, xOff, yOff)
//								 to behave differently
//		UL, 2000-07-03: 2.4.0: - several changes related to support of
//								 string columns / null values
//
//	AUTHOR:
//		U. Lammers (UL), Dec 17 11:48:12 MET DST 1997
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/selectlib/src/selcore/SelectParser.cc,v 1.11 2009/06/26 15:51:59 aibarra Exp $
///

#include <string>

#include "basicdefs.h"
#include "Selector.h"
#include "NumericFunctors.h"
#include "VectorFunctors.h"
#include "RegionFilter.h"
#include "StringFunctors.h"
#include "SelectBlockFuncs.h"

SelectorGlobals selectorGlobalsInstance = {
		0,		//	pointer to symbol table
		0,		//	expression tree
		true,	//	tree can be evaluated in logical context
		0,		//	table descriptor
		0		//	evaluator
};
SelectorGlobals *selectorGlobals = &selectorGlobalsInstance;

static void prependSetName(std::string *s)
{
	if ((*s)[0] == '[' || (*s)[0] == '+')
		s->insert(0, selectorGlobals->tableDescriptor ?
						selectorGlobals->tableDescriptor->setName() : "");
}

#define yylex		selectlex
extern int selectlex();			//	this is the name of the lexer function
								//	that flex generates with the -Pselect
								//	option; we do need a distinct name
								//	in order to avoid name clashes with
								//	other lexers in the SAS

namespace SelectParser {

extern void yyerror(char *);	//	The locally added functions in the
								//	lexer are in a namespace SelectParser


#line 92 "SelectParser.y"
typedef union {
	OpNode		yNode;
	std::string	*yFileName;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		458
#define	YYFLAG		-32768
#define	YYNTBASE	64

#define YYTRANSLATE(x) ((unsigned)(x) <= 311 ? yytranslate[x] : 73)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    58,
    59,     2,     2,    60,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    63,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    61,     2,    62,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    14,    18,    21,    25,
    29,    33,    37,    41,    45,    49,    53,    57,    61,    65,
    69,    73,    77,    81,    85,    89,    93,    97,   106,   115,
   126,   139,   152,   167,   182,   199,   216,   235,   258,   283,
   292,   303,   312,   323,   330,   337,   346,   351,   362,   375,
   390,   394,   399,   404,   406,   410,   414,   418,   422,   431,
   440,   444,   448,   452,   456,   460,   464,   468,   472,   476,
   480,   484,   487,   492,   499,   502,   507,   511,   516,   520,
   525,   527,   529,   531,   535,   539,   543,   547,   551,   558,
   561,   570,   577,   586,   590,   595,   600,   606,   611,   614,
   618,   622,   624,   626,   632,   636,   640,   642,   644,   648,
   652,   656,   660,   662,   666,   669,   674,   679,   684,   689,
   692,   697,   702,   707,   712,   716,   722,   728,   734
};

static const short yyrhs[] = {    65,
     0,    66,     0,    22,     0,    23,     0,    56,     0,    65,
    10,    65,     0,    65,     9,    65,     0,    11,    65,     0,
    66,    36,    66,     0,    66,    36,    65,     0,    65,    36,
    66,     0,    65,    36,    65,     0,    66,    37,    66,     0,
    66,    37,    65,     0,    65,    37,    66,     0,    65,    37,
    65,     0,    66,    32,    66,     0,    66,    33,    66,     0,
    66,    34,    66,     0,    66,    35,    66,     0,    58,    65,
    59,     0,    69,    36,    69,     0,    69,    37,    69,     0,
    69,    32,    69,     0,    69,    33,    69,     0,    69,    34,
    69,     0,    69,    35,    69,     0,    47,    58,    66,    60,
    66,    60,    66,    59,     0,    48,    58,    65,    60,    65,
    60,    65,    59,     0,    42,    58,    66,    60,    66,    60,
    66,    60,    66,    59,     0,    58,    66,    60,    66,    59,
    15,    42,    58,    66,    60,    66,    59,     0,    43,    58,
    66,    60,    66,    60,    66,    60,    66,    60,    66,    59,
     0,    58,    66,    60,    66,    59,    15,    43,    58,    66,
    60,    66,    60,    66,    59,     0,    44,    58,    66,    60,
    66,    60,    66,    60,    66,    60,    66,    60,    66,    59,
     0,    58,    66,    60,    66,    59,    15,    44,    58,    66,
    60,    66,    60,    66,    60,    66,    59,     0,    45,    58,
    66,    60,    66,    60,    66,    60,    66,    60,    66,    60,
    66,    60,    66,    59,     0,    58,    66,    60,    66,    59,
    15,    45,    58,    66,    60,    66,    60,    66,    60,    66,
    60,    66,    59,     0,    46,    58,    66,    60,    66,    60,
    66,    60,    66,    60,    66,    60,    66,    60,    66,    60,
    66,    60,    66,    60,    66,    59,     0,    58,    66,    60,
    66,    59,    15,    46,    58,    66,    60,    66,    60,    66,
    60,    66,    60,    66,    60,    66,    60,    66,    60,    66,
    59,     0,    24,    58,    70,    60,    66,    60,    66,    59,
     0,    58,    66,    60,    66,    59,    15,    24,    58,    70,
    59,     0,    25,    58,    70,    60,    66,    60,    66,    59,
     0,    58,    66,    60,    66,    59,    15,    25,    58,    70,
    59,     0,    12,    58,    57,    60,    66,    59,     0,    66,
    15,    12,    58,    57,    59,     0,    14,    58,    57,    60,
    66,    60,    66,    59,     0,    14,    58,    57,    59,     0,
    58,    66,    60,    66,    59,    15,    14,    58,    57,    59,
     0,    13,    58,    57,    60,    66,    60,    66,    60,    66,
    60,    66,    59,     0,    58,    66,    60,    66,    59,    15,
    13,    58,    57,    60,    66,    60,    66,    59,     0,    66,
    15,    71,     0,    55,    58,    50,    59,     0,    55,    58,
    51,    59,     0,    49,     0,    66,    36,    69,     0,    69,
    36,    66,     0,    66,    37,    69,     0,    69,    37,    66,
     0,    30,    58,    67,    60,    66,    60,    67,    59,     0,
    67,    15,    30,    58,    67,    60,    66,    59,     0,    66,
     3,    66,     0,    66,     4,    66,     0,    66,     5,    66,
     0,    66,     6,    66,     0,    66,     8,    66,     0,    66,
     7,    66,     0,    66,    16,    66,     0,    66,    17,    66,
     0,    66,    18,    66,     0,    66,    19,    66,     0,    66,
    20,    66,     0,    21,    66,     0,    38,    58,    66,    59,
     0,    39,    58,    66,    60,    66,    59,     0,     4,    66,
     0,    41,    58,    69,    59,     0,    58,    66,    59,     0,
    67,    61,    53,    62,     0,    67,     5,    67,     0,    31,
    58,    67,    59,     0,    53,     0,    50,     0,    51,     0,
    67,     3,    67,     0,    67,     4,    67,     0,    66,     5,
    67,     0,    67,     5,    66,     0,    67,     6,    66,     0,
    29,    58,    67,    60,    67,    59,     0,     4,    67,     0,
    28,    58,    66,    60,    66,    60,    66,    59,     0,    27,
    58,    66,    60,    66,    59,     0,    26,    58,    66,    60,
    66,    60,    66,    59,     0,    61,    63,    62,     0,    61,
    66,    63,    62,     0,    61,    63,    66,    62,     0,    61,
    66,    63,    66,    62,     0,    40,    58,    69,    59,     0,
    69,    68,     0,    69,     3,    69,     0,    58,    69,    59,
     0,    54,     0,    52,     0,    70,    60,    66,    60,    66,
     0,    66,    60,    66,     0,    71,    60,    72,     0,    72,
     0,    63,     0,    61,    63,    62,     0,    58,    63,    62,
     0,    61,    63,    59,     0,    58,    63,    59,     0,    66,
     0,    61,    66,    62,     0,    66,    63,     0,    61,    66,
    63,    62,     0,    61,    66,    63,    59,     0,    58,    66,
    63,    62,     0,    58,    66,    63,    59,     0,    63,    66,
     0,    61,    63,    66,    62,     0,    61,    63,    66,    59,
     0,    58,    63,    66,    62,     0,    58,    63,    66,    59,
     0,    66,    63,    66,     0,    61,    66,    63,    66,    62,
     0,    58,    66,    63,    66,    62,     0,    61,    66,    63,
    66,    59,     0,    58,    66,    63,    66,    59,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   131,   133,   136,   137,   138,   139,   140,   141,   142,   143,
   144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
   154,   155,   156,   157,   158,   159,   160,   161,   165,   169,
   173,   177,   181,   186,   191,   196,   201,   207,   213,   220,
   223,   226,   230,   234,   238,   242,   246,   250,   254,   258,
   262,   265,   274,   275,   276,   277,   278,   279,   280,   282,
   285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
   295,   296,   297,   300,   304,   305,   308,   309,   310,   311,
   312,   313,   314,   316,   317,   318,   319,   320,   321,   323,
   324,   326,   328,   331,   332,   333,   334,   336,   340,   345,
   348,   349,   350,   352,   355,   358,   362,   366,   367,   368,
   369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
   379,   380,   381,   382,   383,   384,   385,   386,   387
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PLUS","MINUS",
"MULT","DIV","EXPO","MODULO","ANDIF","ORIF","NOT","GTI","MASK","REGION","IN",
"AND","OR","XOR","LSHIFT","RSHIFT","BITCOMPL","TRUECONST","FALSECONST","POLYGONFUNC",
"POLYGONFUNC2","VECTOR","SKY","UNIT","CROSSPROD","CONE","NORM","LT","LE","GT",
"GE","EQ","NE","AFUNC","AFUNC2","SFUNC","ASFUNC","SPATFUNC4","SPATFUNC5","SPATFUNC6",
"SPATFUNC7","SPATFUNC10","NEAR","IFTHENELSE","BIDENT","IIDENT","RIDENT","SIDENT",
"NLITERAL","SLITERAL","ISNULL","SELECTED","FILENAME","'('","')'","','","'['",
"']'","':'","expr","logic","arith","vector","textrange","text","pointlist","intervallist",
"intervalspec", NULL
};
#endif

static const short yyr1[] = {     0,
    64,    64,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    67,    67,    67,    67,    67,    67,    67,
    67,    67,    67,    68,    68,    68,    68,    69,    69,    69,
    69,    69,    69,    70,    70,    71,    71,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
    72,    72,    72,    72,    72,    72,    72,    72,    72
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     3,     3,     2,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     8,     8,    10,
    12,    12,    14,    14,    16,    16,    18,    22,    24,     8,
    10,     8,    10,     6,     6,     8,     4,    10,    12,    14,
     3,     4,     4,     1,     3,     3,     3,     3,     8,     8,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     2,     4,     6,     2,     4,     3,     4,     3,     4,
     1,     1,     1,     3,     3,     3,     3,     3,     6,     2,
     8,     6,     8,     3,     4,     4,     5,     4,     2,     3,
     3,     1,     1,     5,     3,     3,     1,     1,     3,     3,
     3,     3,     1,     3,     2,     4,     4,     4,     4,     2,
     4,     4,     4,     4,     3,     5,     5,     5,     5
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,     0,     0,     3,     4,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    54,    82,    83,
   103,    81,   102,     0,     5,     0,     1,     2,     0,     0,
     0,    75,    90,     8,     0,     0,     0,     0,    72,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    99,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    21,    77,
     0,   101,     7,     6,    12,    11,    16,    15,    61,    62,
    63,    86,    64,    66,    65,     0,     0,     0,   108,   113,
    51,   107,    67,    68,    69,    70,    71,    17,    18,    19,
    20,    10,     9,    55,    14,    13,    57,    84,    85,    87,
    79,    88,     0,     0,   100,    24,    25,    26,    27,     0,
    56,    22,    58,    23,     0,     0,     0,     0,    47,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    80,    73,
     0,     0,    98,    76,     0,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,     0,     0,     0,     0,   120,
   115,     0,     0,    78,    94,     0,     0,     0,     0,     0,
   105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   112,   110,
     0,     0,   111,   109,     0,   114,     0,   125,   106,     0,
    96,    95,     0,    44,     0,     0,     0,     0,     0,    92,
     0,    89,     0,    74,     0,     0,     0,     0,     0,     0,
     0,     0,    45,   124,   123,   119,   118,     0,   122,   121,
   117,   116,     0,     0,    97,     0,     0,   104,   104,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   129,   127,
   128,   126,     0,     0,    46,    40,    42,    93,    91,    59,
     0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    60,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    30,     0,     0,     0,     0,     0,    48,
    41,     0,    43,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    49,    32,     0,     0,     0,     0,     0,    31,     0,     0,
     0,     0,     0,     0,     0,     0,   104,     0,     0,     0,
     0,    34,     0,     0,    50,    33,     0,     0,     0,     0,
     0,     0,     0,     0,    36,     0,    35,     0,     0,     0,
     0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
     0,    38,     0,     0,    39,     0,     0,     0
};

static const short yydefgoto[] = {   456,
    37,   121,    50,   110,    40,   116,   161,   162
};

static const short yypact[] = {  2574,
  2665,  2574,   -53,   -35,   -29,  2665,-32768,-32768,   -23,   -21,
     3,    39,    42,    43,    57,    71,    84,    95,   102,   119,
   128,   130,   131,   138,   141,   155,   164,-32768,-32768,-32768,
-32768,-32768,-32768,   165,-32768,  2574,   256,  2694,    41,   279,
  2665,-32768,   108,-32768,  2694,   114,   118,   167,-32768,   146,
  2665,  2665,  2665,  2665,  2665,  2665,  2665,  2665,  2665,  2665,
   402,   402,  2665,  2665,  2665,  2665,  2665,  2665,  2574,   -11,
   361,   972,   111,  2574,  2574,  2574,  2574,  2665,  2665,  2665,
  2665,  2665,  2665,   455,  2665,  2665,  2665,  2665,  2665,  2665,
  2665,  2665,  2665,  2574,  2574,  2665,  2665,  2665,  2665,   195,
   174,   402,   402,   402,   402,   402,  2627,  2627,   499,-32768,
    14,   169,   170,   -17,   978,   184,   187,  1007,  1036,  1042,
   874,   113,   188,   265,   796,  1065,   402,    45,   117,  1071,
  1100,  1129,  1135,  1158,  1164,   224,   176,   197,-32768,-32768,
  2665,-32768,    13,   173,-32768,  2729,-32768,  2729,     2,     2,
   251,   108,   251,-32768,   251,   201,   527,   555,  2665,   235,
   203,-32768,  1107,   953,  1014,   325,   325,   874,   874,   874,
   874,-32768,  2729,   100,-32768,  2729,   100,   175,   175,   251,
   108,   251,   206,   212,   219,     1,     1,     1,     1,  2627,
   874,     1,   874,     1,   884,   302,  2665,  2665,-32768,  2665,
  2665,  2665,  2665,  2665,  2665,  2665,  2665,  2665,-32768,-32768,
  2665,   153,-32768,-32768,  2665,  2665,  2665,  2665,  2665,  2665,
  2574,-32768,-32768,  2152,   226,   728,   120,   767,     8,   874,
  2665,   483,  2665,-32768,-32768,   700,   912,  2158,  1193,  1222,
   874,  1228,  1251,  1257,  2181,  1286,   332,  1315,  2187,  1321,
  1344,  1350,  1379,  1408,  1414,   236,   280,   238,-32768,-32768,
   616,   806,-32768,-32768,   634,-32768,   845,   874,-32768,   354,
-32768,-32768,   723,-32768,  2665,  2665,  2665,  2665,  2665,-32768,
  2665,-32768,  2665,-32768,  2665,  2665,  2665,  2665,  2665,  2665,
  2574,  2548,-32768,-32768,-32768,-32768,-32768,   640,-32768,-32768,
-32768,-32768,   663,  2665,-32768,  1437,  2215,  2244,  2250,  2272,
  2278,   358,  1443,  1472,  1501,  1507,  1530,  2307,   533,   241,
   242,   245,   259,   267,   281,   288,   289,   290,-32768,-32768,
-32768,-32768,  2335,  2665,-32768,-32768,-32768,-32768,-32768,-32768,
  2665,  2665,  2665,  2665,  2665,-32768,-32768,   237,   266,  2665,
  2665,  2665,  2665,  2665,  2665,  2665,-32768,  1536,  2341,  1565,
  1594,  1600,  1623,   306,   308,    -2,   125,  1629,  1658,  1687,
  1693,  1716,  2665,-32768,  2665,  2665,  2665,  2665,  2665,-32768,
-32768,  2665,-32768,  2665,  2665,  2665,  2665,  2665,  2364,  2370,
  1722,  1751,  1780,  1786,  1809,  2398,  1815,  1844,  1873,  1879,
-32768,-32768,  2665,  2665,  2665,  2665,  2665,-32768,  2665,  2665,
  2665,  2665,  2427,  1902,  1908,  2433,   874,  2455,  1937,  1966,
  1972,-32768,  2665,  2665,-32768,-32768,  2665,  2665,  2665,  2461,
  1995,  2490,  2001,  2030,-32768,  2665,-32768,  2665,  2665,  2059,
  2518,  2065,  2665,-32768,  2665,  2088,  2094,  2665,  2665,  2524,
  2123,-32768,  2665,  2547,-32768,   349,   368,-32768
};

static const short yypgoto[] = {-32768,
    36,     0,   394,-32768,    60,   -49,-32768,   137
};


#define	YYLAST		2764


static const short yytable[] = {    38,
    42,    45,   117,   102,    46,    49,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,    78,    79,    80,    81,
    82,    83,    47,    85,    86,    87,    88,    89,    48,    85,
    86,    87,    88,    89,    51,    72,    52,    44,   137,   138,
   111,   199,   200,    96,    97,    98,    99,   102,    76,    77,
   115,   115,   118,   119,   120,   100,   381,   382,   125,   126,
    53,   109,   130,   131,   132,   133,   134,   135,    45,   266,
   267,    71,   140,    45,    45,   146,   148,   149,   150,   151,
   153,   154,   155,   160,   163,   164,   165,   166,   167,   168,
   169,   170,   171,   173,   176,    73,    54,   180,   182,    55,
    56,   101,   102,   213,   136,   109,   191,   193,   196,   143,
   144,   145,   147,   102,    57,    96,    97,    98,    99,   102,
   128,   129,    78,    79,    80,    81,    82,    83,    58,   172,
   175,   103,   104,   105,   106,    85,    86,    87,    88,    89,
   224,    59,   103,   104,   105,   106,   107,   108,    96,    97,
    98,    99,    60,   174,   177,   102,   227,   229,   230,    61,
   109,   185,   186,   187,   188,   189,   192,   194,   101,   142,
   112,   109,   207,   101,   113,   214,    62,   109,   140,    98,
    99,    74,   262,   383,   382,    63,   212,    64,    65,   111,
    96,    97,    98,    99,   236,    66,   238,   239,    67,   240,
   241,   242,   243,   244,   245,   246,   101,   248,    76,    77,
   249,   142,    68,   109,   250,   251,   252,   253,   254,   255,
    45,    69,    70,   114,   183,   261,   184,   265,   197,   198,
   268,   160,    74,    75,   222,   101,   273,    78,    79,    80,
    81,    82,    83,   202,    74,    75,   203,   208,   101,   212,
    85,    86,    87,    88,    89,   223,   256,    82,   225,    76,
    77,   298,   232,   233,    74,    75,   303,    96,    97,    98,
    99,    76,    77,   234,   306,   307,   308,   309,   310,   109,
   311,   102,   258,   221,   313,   314,   315,   316,   317,   318,
    45,    76,    77,   364,   292,   291,   293,   231,   348,   349,
   366,   367,   350,   333,    78,    79,    80,    81,    82,    83,
   103,   104,   105,   106,   107,   108,   351,    85,    86,    87,
    88,    89,   365,   209,   352,   101,   319,    78,    79,    80,
    81,    82,    83,   358,    96,    97,    98,    99,   353,   109,
   359,   360,   361,   362,   363,   354,   355,   356,   457,   115,
   115,   368,   369,   370,   371,   372,    96,    97,    98,    99,
    96,    97,    98,    99,   237,   379,   380,   458,   269,    74,
    75,     0,   389,     0,   390,   391,   392,   393,   394,     0,
     0,   395,     0,   396,   397,   398,   399,   400,     0,     0,
   282,     0,   101,    39,    43,    39,    76,    77,     0,     0,
     0,     0,   413,   414,   415,   416,   417,     0,   418,   419,
   420,   421,     0,   304,   101,     0,   340,     0,   101,   139,
     0,     0,   430,   431,     0,     0,   432,   433,   434,    39,
     0,     0,     0,     0,     0,   440,     0,   441,   442,     0,
     0,    19,   446,     0,   447,     0,     0,   450,   451,   122,
   123,   124,   454,    31,     0,    33,     0,     0,     1,   127,
     0,     0,    39,     0,     0,     0,   156,    39,    39,    39,
    39,     0,     0,   152,     0,     6,     0,     0,     0,     0,
    11,    12,    13,    14,     0,    16,     1,    39,    39,   178,
   179,   181,    17,    18,     0,    20,     0,     0,     0,     0,
     0,     0,     1,     6,    29,    30,     0,    32,    11,    12,
    13,    14,   157,    16,     0,   158,     0,   159,     0,     6,
    17,    18,     0,    20,    11,    12,    13,    14,     0,    16,
     1,     0,    29,    30,     0,    32,    17,    18,     0,    20,
   157,    74,    75,   158,     0,   159,     0,     6,    29,    30,
     0,    32,    11,    12,    13,    14,    41,    16,     1,     0,
     0,   195,     0,     0,    17,    18,     0,    20,    76,    77,
     0,     0,     0,     0,     0,     6,    29,    30,     0,    32,
    11,    12,    13,    14,    41,    16,     0,     0,     0,   226,
     0,   347,    17,    18,     0,    20,     0,     0,     0,     0,
   247,     0,     0,     0,    29,    30,     0,    32,     0,     0,
     0,     0,    41,     0,    39,     0,     0,   228,    78,    79,
    80,    81,    82,    83,     0,     0,   270,     0,     0,     0,
     0,    85,    86,    87,    88,    89,    78,    79,    80,    81,
    82,    83,    78,    79,    80,    81,    82,    83,     0,    85,
    86,    87,    88,    89,     0,    85,    86,    87,    88,    89,
     0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
    83,     0,     0,     0,   294,     0,   312,   295,    85,    86,
    87,    88,    89,     0,    39,     0,     0,     0,     0,     0,
     0,     0,   299,     0,     0,   300,     0,     0,   329,     0,
     0,   330,    78,    79,    80,    81,    82,    83,     0,     0,
     0,     0,     0,     0,     0,    85,    86,    87,    88,    89,
     0,   331,     0,     0,   332,    78,    79,    80,    81,    82,
    83,     1,     0,     0,     0,     0,     0,     0,    85,    86,
    87,    88,    89,     0,     0,     0,     0,     0,     6,     0,
     0,     0,     0,    11,    12,    13,    14,     0,    16,     0,
     0,   271,     0,     0,     0,    17,    18,     0,    20,     0,
     1,     0,     0,     0,     0,     0,     0,    29,    30,     0,
    32,     0,     0,     0,   305,    41,   259,     6,     0,   260,
     0,     0,    11,    12,    13,    14,     0,    16,    78,    79,
    80,    81,    82,    83,    17,    18,     0,    20,     0,     1,
     0,    85,    86,    87,    88,    89,    29,    30,     0,    32,
     0,     0,     0,     0,    41,   263,     6,     0,   264,     0,
     0,    11,    12,    13,    14,     0,    16,     0,     0,     0,
     0,     0,     0,    17,    18,     0,    20,     0,     1,     0,
     0,     0,     0,     0,   210,    29,    30,     0,    32,     0,
     0,     0,     0,    41,   296,     6,     0,   297,     0,     0,
    11,    12,    13,    14,     0,    16,    78,    79,    80,    81,
    82,    83,    17,    18,     0,    20,     0,     1,     0,    85,
    86,    87,    88,    89,    29,    30,     0,    32,     0,     0,
     0,     0,    41,   301,     6,     0,   302,     0,     0,    11,
    12,    13,    14,     0,    16,     1,     0,     0,     0,     0,
     0,    17,    18,     0,    20,     0,     0,     0,     0,     0,
     0,     0,     6,    29,    30,     0,    32,    11,    12,    13,
    14,    41,    16,     0,     0,   235,     0,     0,     0,    17,
    18,     0,    20,     0,     0,    78,    79,    80,    81,    82,
    83,    29,    30,     0,    32,     0,     0,     0,    85,    41,
    87,    88,    89,   272,    78,    79,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,     0,    90,    91,    92,    93,    94,    95,    78,
    79,    80,    81,    82,    83,     0,    78,    79,    80,    81,
    82,    83,    85,    86,    87,    88,    89,     0,     0,    85,
   140,   141,    88,    89,     0,     0,     0,   201,    78,    79,
    80,    81,    82,    83,    78,    79,    80,    81,    82,    83,
     0,    85,    86,    87,    88,    89,     0,    85,    86,    87,
    88,    89,     0,     0,     0,     0,   204,    78,    79,    80,
    81,    82,    83,    78,    79,    80,    81,    82,    83,     0,
    85,    86,    87,    88,    89,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   205,     0,     0,     0,     0,
     0,   206,    78,    79,    80,    81,    82,    83,     0,    78,
    79,    80,    81,    82,    83,    85,    86,    87,    88,    89,
     0,     0,     0,     0,   211,    88,    89,     0,     0,     0,
   215,    78,    79,    80,    81,    82,    83,    78,    79,    80,
    81,    82,    83,     0,    85,    86,    87,    88,    89,     0,
    85,    86,    87,    88,    89,     0,     0,     0,     0,   216,
    78,    79,    80,    81,    82,    83,    78,    79,    80,    81,
    82,    83,     0,    85,    86,    87,    88,    89,     0,    85,
    86,    87,    88,    89,     0,     0,     0,     0,   217,     0,
     0,     0,     0,     0,   218,    78,    79,    80,    81,    82,
    83,     0,     0,     0,     0,     0,     0,     0,    85,    86,
    87,    88,    89,     0,     0,     0,     0,   219,     0,     0,
     0,     0,     0,   220,    78,    79,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,     0,    85,    86,    87,
    88,    89,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   275,    78,    79,    80,    81,    82,    83,    78,
    79,    80,    81,    82,    83,     0,    85,    86,    87,    88,
    89,     0,    85,    86,    87,    88,    89,     0,     0,     0,
     0,   276,     0,     0,     0,     0,     0,   277,    78,    79,
    80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
     0,    85,    86,    87,    88,    89,     0,     0,     0,     0,
   278,     0,     0,     0,     0,     0,   279,    78,    79,    80,
    81,    82,    83,    78,    79,    80,    81,    82,    83,     0,
    85,    86,    87,    88,    89,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   281,    78,    79,    80,    81,
    82,    83,    78,    79,    80,    81,    82,    83,     0,    85,
    86,    87,    88,    89,     0,    85,    86,    87,    88,    89,
     0,     0,     0,     0,   283,     0,     0,     0,     0,     0,
   285,    78,    79,    80,    81,    82,    83,     0,     0,     0,
     0,     0,     0,     0,    85,    86,    87,    88,    89,     0,
     0,     0,     0,   286,     0,     0,     0,     0,     0,   287,
    78,    79,    80,    81,    82,    83,    78,    79,    80,    81,
    82,    83,     0,    85,    86,    87,    88,    89,     0,    85,
    86,    87,    88,    89,     0,     0,     0,     0,   288,    78,
    79,    80,    81,    82,    83,    78,    79,    80,    81,    82,
    83,     0,    85,    86,    87,    88,    89,     0,    85,    86,
    87,    88,    89,     0,     0,     0,     0,   289,     0,     0,
     0,     0,     0,   290,    78,    79,    80,    81,    82,    83,
     0,     0,     0,     0,     0,     0,     0,    85,    86,    87,
    88,    89,     0,     0,     0,     0,   334,     0,     0,     0,
     0,     0,   341,    78,    79,    80,    81,    82,    83,    78,
    79,    80,    81,    82,    83,     0,    85,    86,    87,    88,
    89,     0,    85,    86,    87,    88,    89,     0,     0,     0,
     0,   342,    78,    79,    80,    81,    82,    83,    78,    79,
    80,    81,    82,    83,     0,    85,    86,    87,    88,    89,
     0,    85,    86,    87,    88,    89,     0,     0,     0,     0,
   343,     0,     0,     0,     0,     0,   344,    78,    79,    80,
    81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
    85,    86,    87,    88,    89,     0,     0,     0,     0,   345,
     0,     0,     0,     0,     0,   373,    78,    79,    80,    81,
    82,    83,    78,    79,    80,    81,    82,    83,     0,    85,
    86,    87,    88,    89,     0,    85,    86,    87,    88,    89,
     0,     0,     0,     0,   375,    78,    79,    80,    81,    82,
    83,    78,    79,    80,    81,    82,    83,     0,    85,    86,
    87,    88,    89,     0,    85,    86,    87,    88,    89,     0,
     0,     0,     0,   376,     0,     0,     0,     0,     0,   377,
    78,    79,    80,    81,    82,    83,     0,     0,     0,     0,
     0,     0,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   378,     0,     0,     0,     0,     0,   384,    78,
    79,    80,    81,    82,    83,    78,    79,    80,    81,    82,
    83,     0,    85,    86,    87,    88,    89,     0,    85,    86,
    87,    88,    89,     0,     0,     0,     0,   385,    78,    79,
    80,    81,    82,    83,    78,    79,    80,    81,    82,    83,
     0,    85,    86,    87,    88,    89,     0,    85,    86,    87,
    88,    89,     0,     0,     0,     0,   386,     0,     0,     0,
     0,     0,   387,    78,    79,    80,    81,    82,    83,     0,
     0,     0,     0,     0,     0,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   388,     0,     0,     0,     0,
     0,   403,    78,    79,    80,    81,    82,    83,    78,    79,
    80,    81,    82,    83,     0,    85,    86,    87,    88,    89,
     0,    85,    86,    87,    88,    89,     0,     0,     0,     0,
   404,    78,    79,    80,    81,    82,    83,    78,    79,    80,
    81,    82,    83,     0,    85,    86,    87,    88,    89,     0,
    85,    86,    87,    88,    89,     0,     0,     0,     0,   405,
     0,     0,     0,     0,     0,   406,    78,    79,    80,    81,
    82,    83,     0,     0,     0,     0,     0,     0,     0,    85,
    86,    87,    88,    89,     0,     0,     0,     0,   407,     0,
     0,     0,     0,     0,   409,    78,    79,    80,    81,    82,
    83,    78,    79,    80,    81,    82,    83,     0,    85,    86,
    87,    88,    89,     0,    85,    86,    87,    88,    89,     0,
     0,     0,     0,   410,    78,    79,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,     0,    85,    86,    87,
    88,    89,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   411,     0,     0,     0,     0,     0,   412,    78,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,    85,    86,    87,    88,    89,     0,     0,     0,
     0,   423,     0,     0,     0,     0,     0,   424,    78,    79,
    80,    81,    82,    83,    78,    79,    80,    81,    82,    83,
     0,    85,    86,    87,    88,    89,     0,    85,    86,    87,
    88,    89,     0,     0,     0,     0,   427,    78,    79,    80,
    81,    82,    83,    78,    79,    80,    81,    82,    83,     0,
    85,    86,    87,    88,    89,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   428,     0,     0,     0,     0,
     0,   429,    78,    79,    80,    81,    82,    83,     0,     0,
     0,     0,     0,     0,     0,    85,    86,    87,    88,    89,
     0,     0,     0,     0,   436,     0,     0,     0,     0,     0,
   438,    78,    79,    80,    81,    82,    83,    78,    79,    80,
    81,    82,    83,     0,    85,    86,    87,    88,    89,     0,
    85,    86,    87,    88,    89,     0,     0,     0,     0,   439,
    78,    79,    80,    81,    82,    83,    78,    79,    80,    81,
    82,    83,     0,    85,    86,    87,    88,    89,     0,    85,
    86,    87,    88,    89,     0,     0,     0,     0,   443,     0,
     0,     0,     0,     0,   445,    78,    79,    80,    81,    82,
    83,     0,     0,     0,     0,     0,     0,     0,    85,    86,
    87,    88,    89,     0,     0,     0,     0,   448,     0,     0,
     0,     0,     0,   449,    78,    79,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,     0,    85,    86,    87,
    88,    89,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   453,    78,    79,    80,    81,    82,    83,    78,
    79,    80,    81,    82,    83,     0,    85,    86,    87,    88,
    89,     0,    85,    86,    87,    88,    89,     0,     0,     0,
   257,     0,     0,     0,     0,     0,   274,    78,    79,    80,
    81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
    85,    86,    87,    88,    89,     0,     0,     0,     0,   280,
     0,     0,     0,     0,     0,   284,    78,    79,    80,    81,
    82,    83,    78,    79,    80,    81,    82,    83,     0,    85,
    86,    87,    88,    89,     0,    85,    86,    87,    88,    89,
     0,     0,     0,   335,    78,    79,    80,    81,    82,    83,
    78,    79,    80,    81,    82,    83,     0,    85,    86,    87,
    88,    89,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   336,     0,     0,     0,     0,     0,   337,    78,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     0,     0,    85,    86,    87,    88,    89,     0,     0,     0,
   338,     0,     0,     0,     0,     0,   339,    78,    79,    80,
    81,    82,    83,    78,    79,    80,    81,    82,    83,     0,
    85,    86,    87,    88,    89,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   346,    78,    79,    80,    81,
    82,    83,    78,    79,    80,    81,    82,    83,     0,    85,
    86,    87,    88,    89,     0,    85,    86,    87,    88,    89,
     0,     0,     0,   357,     0,     0,     0,     0,     0,   374,
    78,    79,    80,    81,    82,    83,     0,     0,     0,     0,
     0,     0,     0,    85,    86,    87,    88,    89,     0,     0,
     0,     0,   401,     0,     0,     0,     0,     0,   402,    78,
    79,    80,    81,    82,    83,    78,    79,    80,    81,    82,
    83,     0,    85,    86,    87,    88,    89,     0,    85,    86,
    87,    88,    89,     0,     0,     0,   408,    78,    79,    80,
    81,    82,    83,    78,    79,    80,    81,    82,    83,     0,
    85,    86,    87,    88,    89,     0,    85,    86,    87,    88,
    89,     0,     0,     0,     0,   422,     0,     0,     0,     0,
     0,   425,    78,    79,    80,    81,    82,    83,     0,     0,
     0,     0,     0,     0,     0,    85,    86,    87,    88,    89,
     0,     0,     0,   426,     0,     0,     0,     0,     0,   435,
    78,    79,    80,    81,    82,    83,    78,    79,    80,    81,
    82,    83,     0,    85,    86,    87,    88,    89,     0,    85,
    86,    87,    88,    89,     0,     0,     0,     0,   437,    78,
    79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
   320,   321,    85,    86,    87,    88,    89,     0,     0,     0,
     0,   322,   323,     0,     0,     0,   444,     1,     0,     0,
     0,     0,   452,     0,     2,     3,     4,     5,     0,   324,
   325,   326,   327,   328,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,   455,     0,     0,     0,     0,
     0,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     1,    36,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     6,     0,     0,
     0,     0,    11,    12,    13,    14,     0,    16,     0,     0,
     0,     0,     0,     0,    17,    18,    19,    20,     1,     0,
     0,     0,     0,     0,     0,     0,    29,    30,    31,    32,
    33,     0,     0,     0,   190,     6,     0,     0,     0,     0,
    11,    12,    13,    14,     0,    16,    78,    79,    80,    81,
    82,    83,    17,    18,     0,    20,     0,     0,    84,    85,
    86,    87,    88,    89,    29,    30,     0,    32,     0,     0,
     0,     0,    41,     0,     0,    90,    91,    92,    93,    94,
    95,    78,    79,    80,    81,    82,    83,     0,     0,     0,
     0,     0,     0,    84,    85,    86,    87,    88,    89,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    90,    91,    92,    93
};

static const short yycheck[] = {     0,
     1,     2,    52,     3,    58,     6,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    58,    16,    17,    18,    19,    20,    58,    16,
    17,    18,    19,    20,    58,    36,    58,     2,    50,    51,
    41,    59,    60,     3,     4,     5,     6,     3,    36,    37,
    51,    52,    53,    54,    55,    15,    59,    60,    59,    60,
    58,    61,    63,    64,    65,    66,    67,    68,    69,    62,
    63,    36,    59,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    36,    58,    98,    99,    58,
    58,    61,     3,    59,    69,    61,   107,   108,   109,    74,
    75,    76,    77,     3,    58,     3,     4,     5,     6,     3,
    61,    62,     3,     4,     5,     6,     7,     8,    58,    94,
    95,    32,    33,    34,    35,    16,    17,    18,    19,    20,
   141,    58,    32,    33,    34,    35,    36,    37,     3,     4,
     5,     6,    58,    94,    95,     3,   157,   158,   159,    58,
    61,   102,   103,   104,   105,   106,   107,   108,    61,    59,
    57,    61,    60,    61,    57,    59,    58,    61,    59,     5,
     6,     9,    63,    59,    60,    58,   127,    58,    58,   190,
     3,     4,     5,     6,   195,    58,   197,   198,    58,   200,
   201,   202,   203,   204,   205,   206,    61,   208,    36,    37,
   211,    59,    58,    61,   215,   216,   217,   218,   219,   220,
   221,    58,    58,    57,    30,   226,    53,   228,    60,    60,
   231,   232,     9,    10,    59,    61,   237,     3,     4,     5,
     6,     7,     8,    60,     9,    10,    60,    60,    61,   190,
    16,    17,    18,    19,    20,    59,   221,     7,    58,    36,
    37,   262,    60,    58,     9,    10,   267,     3,     4,     5,
     6,    36,    37,    62,   275,   276,   277,   278,   279,    61,
   281,     3,    57,    60,   285,   286,   287,   288,   289,   290,
   291,    36,    37,    57,    15,    60,    59,    63,    58,    58,
   350,   351,    58,   304,     3,     4,     5,     6,     7,     8,
    32,    33,    34,    35,    36,    37,    58,    16,    17,    18,
    19,    20,    57,    59,    58,    61,   291,     3,     4,     5,
     6,     7,     8,   334,     3,     4,     5,     6,    58,    61,
   341,   342,   343,   344,   345,    58,    58,    58,     0,   350,
   351,   352,   353,   354,   355,   356,     3,     4,     5,     6,
     3,     4,     5,     6,    63,    60,    59,     0,   232,     9,
    10,    -1,   373,    -1,   375,   376,   377,   378,   379,    -1,
    -1,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
    59,    -1,    61,     0,     1,     2,    36,    37,    -1,    -1,
    -1,    -1,   403,   404,   405,   406,   407,    -1,   409,   410,
   411,   412,    -1,    60,    61,    -1,    59,    -1,    61,    59,
    -1,    -1,   423,   424,    -1,    -1,   427,   428,   429,    36,
    -1,    -1,    -1,    -1,    -1,   436,    -1,   438,   439,    -1,
    -1,    40,   443,    -1,   445,    -1,    -1,   448,   449,    56,
    57,    58,   453,    52,    -1,    54,    -1,    -1,     4,    58,
    -1,    -1,    69,    -1,    -1,    -1,    12,    74,    75,    76,
    77,    -1,    -1,    80,    -1,    21,    -1,    -1,    -1,    -1,
    26,    27,    28,    29,    -1,    31,     4,    94,    95,    96,
    97,    98,    38,    39,    -1,    41,    -1,    -1,    -1,    -1,
    -1,    -1,     4,    21,    50,    51,    -1,    53,    26,    27,
    28,    29,    58,    31,    -1,    61,    -1,    63,    -1,    21,
    38,    39,    -1,    41,    26,    27,    28,    29,    -1,    31,
     4,    -1,    50,    51,    -1,    53,    38,    39,    -1,    41,
    58,     9,    10,    61,    -1,    63,    -1,    21,    50,    51,
    -1,    53,    26,    27,    28,    29,    58,    31,     4,    -1,
    -1,    63,    -1,    -1,    38,    39,    -1,    41,    36,    37,
    -1,    -1,    -1,    -1,    -1,    21,    50,    51,    -1,    53,
    26,    27,    28,    29,    58,    31,    -1,    -1,    -1,    63,
    -1,    59,    38,    39,    -1,    41,    -1,    -1,    -1,    -1,
   207,    -1,    -1,    -1,    50,    51,    -1,    53,    -1,    -1,
    -1,    -1,    58,    -1,   221,    -1,    -1,    63,     3,     4,
     5,     6,     7,     8,    -1,    -1,   233,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
     8,    -1,    -1,    -1,    59,    -1,   283,    62,    16,    17,
    18,    19,    20,    -1,   291,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    59,    -1,    -1,    62,    -1,    -1,    59,    -1,
    -1,    62,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    59,    -1,    -1,    62,     3,     4,     5,     6,     7,
     8,     4,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    -1,    21,    -1,
    -1,    -1,    -1,    26,    27,    28,    29,    -1,    31,    -1,
    -1,    62,    -1,    -1,    -1,    38,    39,    -1,    41,    -1,
     4,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,
    53,    -1,    -1,    -1,    62,    58,    59,    21,    -1,    62,
    -1,    -1,    26,    27,    28,    29,    -1,    31,     3,     4,
     5,     6,     7,     8,    38,    39,    -1,    41,    -1,     4,
    -1,    16,    17,    18,    19,    20,    50,    51,    -1,    53,
    -1,    -1,    -1,    -1,    58,    59,    21,    -1,    62,    -1,
    -1,    26,    27,    28,    29,    -1,    31,    -1,    -1,    -1,
    -1,    -1,    -1,    38,    39,    -1,    41,    -1,     4,    -1,
    -1,    -1,    -1,    -1,    59,    50,    51,    -1,    53,    -1,
    -1,    -1,    -1,    58,    59,    21,    -1,    62,    -1,    -1,
    26,    27,    28,    29,    -1,    31,     3,     4,     5,     6,
     7,     8,    38,    39,    -1,    41,    -1,     4,    -1,    16,
    17,    18,    19,    20,    50,    51,    -1,    53,    -1,    -1,
    -1,    -1,    58,    59,    21,    -1,    62,    -1,    -1,    26,
    27,    28,    29,    -1,    31,     4,    -1,    -1,    -1,    -1,
    -1,    38,    39,    -1,    41,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    21,    50,    51,    -1,    53,    26,    27,    28,
    29,    58,    31,    -1,    -1,    62,    -1,    -1,    -1,    38,
    39,    -1,    41,    -1,    -1,     3,     4,     5,     6,     7,
     8,    50,    51,    -1,    53,    -1,    -1,    -1,    16,    58,
    18,    19,    20,    62,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    15,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    -1,    32,    33,    34,    35,    36,    37,     3,
     4,     5,     6,     7,     8,    -1,     3,     4,     5,     6,
     7,     8,    16,    17,    18,    19,    20,    -1,    -1,    16,
    59,    60,    19,    20,    -1,    -1,    -1,    60,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    -1,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    60,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
    -1,    60,     3,     4,     5,     6,     7,     8,    -1,     3,
     4,     5,     6,     7,     8,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    60,    19,    20,    -1,    -1,    -1,
    60,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,
    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,
     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,
    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    -1,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    60,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    60,    -1,    -1,    -1,    -1,    -1,    60,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,
    60,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,
    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,     8,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,
    -1,    -1,    60,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    60,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    60,    -1,    -1,    -1,    -1,    -1,    60,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,
    -1,    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    -1,    16,    17,
    18,    19,    20,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    60,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    -1,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,
    -1,    -1,    60,     3,     4,     5,     6,     7,     8,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
    -1,    60,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    60,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,
    -1,    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,
     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,
    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    -1,    16,    17,
    18,    19,    20,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    -1,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    60,    -1,    -1,    -1,    -1,    -1,    60,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    -1,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    60,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
    -1,    60,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,
    60,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,
    -1,    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,
     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    60,    -1,    -1,
    -1,    -1,    -1,    60,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    -1,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    60,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    59,    -1,    -1,    -1,    -1,    -1,    59,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    59,
    -1,    -1,    -1,    -1,    -1,    59,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    59,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    -1,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    59,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    59,    -1,    -1,    -1,    -1,    -1,    59,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    59,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    59,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    59,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    59,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,
    -1,    59,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    59,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    59,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    13,    14,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    24,    25,    -1,    -1,    -1,    59,     4,    -1,    -1,
    -1,    -1,    59,    -1,    11,    12,    13,    14,    -1,    42,
    43,    44,    45,    46,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    59,    -1,    -1,    -1,    -1,
    -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     4,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,
    -1,    -1,    26,    27,    28,    29,    -1,    31,    -1,    -1,
    -1,    -1,    -1,    -1,    38,    39,    40,    41,     4,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
    54,    -1,    -1,    -1,    58,    21,    -1,    -1,    -1,    -1,
    26,    27,    28,    29,    -1,    31,     3,     4,     5,     6,
     7,     8,    38,    39,    -1,    41,    -1,    -1,    15,    16,
    17,    18,    19,    20,    50,    51,    -1,    53,    -1,    -1,
    -1,    -1,    58,    -1,    -1,    32,    33,    34,    35,    36,
    37,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    32,    33,    34,    35
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror((char*)"parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 131 "SelectParser.y"
{ selectorGlobals->selExpression = yyvsp[0].yNode;
								  selectorGlobals->isSelExprLogic = true; ;
    break;}
case 2:
#line 133 "SelectParser.y"
{ selectorGlobals->selExpression = yyvsp[0].yNode;
								  selectorGlobals->isSelExprLogic = false; ;
    break;}
case 3:
#line 136 "SelectParser.y"
{ yyval.yNode = new TrueNode; ;
    break;}
case 4:
#line 137 "SelectParser.y"
{ yyval.yNode = new FalseNode; ;
    break;}
case 5:
#line 138 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode; ;
    break;}
case 6:
#line 139 "SelectParser.y"
{ yyval.yNode = new OrIf(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 7:
#line 140 "SelectParser.y"
{ yyval.yNode = new AndIf(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 8:
#line 141 "SelectParser.y"
{ yyval.yNode = new Not(yyvsp[0].yNode); ;
    break;}
case 9:
#line 142 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 10:
#line 143 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 11:
#line 144 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 12:
#line 145 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 13:
#line 146 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 14:
#line 147 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 15:
#line 148 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 16:
#line 149 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 17:
#line 150 "SelectParser.y"
{ yyval.yNode = new Lt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 18:
#line 151 "SelectParser.y"
{ yyval.yNode = new Le(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 19:
#line 152 "SelectParser.y"
{ yyval.yNode = new Gt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 20:
#line 153 "SelectParser.y"
{ yyval.yNode = new Ge(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 21:
#line 154 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 22:
#line 155 "SelectParser.y"
{ yyval.yNode = new StrEq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 23:
#line 156 "SelectParser.y"
{ yyval.yNode = new StrNe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 24:
#line 157 "SelectParser.y"
{ yyval.yNode = new StrLt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 25:
#line 158 "SelectParser.y"
{ yyval.yNode = new StrLe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 26:
#line 159 "SelectParser.y"
{ yyval.yNode = new StrGt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 27:
#line 160 "SelectParser.y"
{ yyval.yNode = new StrGe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 28:
#line 162 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 29:
#line 166 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 30:
#line 170 "SelectParser.y"
{ yyval.yNode = yyvsp[-9].yNode;
								  OpNode nd[] = { yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-9].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 31:
#line 174 "SelectParser.y"
{ yyval.yNode = yyvsp[-5].yNode;
								  OpNode nd[] = { yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-10].yNode, yyvsp[-8].yNode };
								  yyvsp[-5].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 32:
#line 178 "SelectParser.y"
{ yyval.yNode = yyvsp[-11].yNode;
								  OpNode nd[] = { yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-11].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 33:
#line 183 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-12].yNode, yyvsp[-10].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 34:
#line 188 "SelectParser.y"
{ yyval.yNode = yyvsp[-13].yNode;
								  OpNode nd[] = { yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-13].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 35:
#line 193 "SelectParser.y"
{ yyval.yNode = yyvsp[-9].yNode;
								  OpNode nd[] = { yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-14].yNode, yyvsp[-12].yNode };
								  yyvsp[-9].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 36:
#line 197 "SelectParser.y"
{ yyval.yNode = yyvsp[-15].yNode;
								  OpNode nd[] = { yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode,
								  yyvsp[-1].yNode };
								  yyvsp[-15].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 37:
#line 203 "SelectParser.y"
{ yyval.yNode = yyvsp[-11].yNode;
								  OpNode nd[] = { yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode,
												  yyvsp[-16].yNode, yyvsp[-14].yNode };
								  yyvsp[-11].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 38:
#line 209 "SelectParser.y"
{ yyval.yNode = yyvsp[-21].yNode;
								  OpNode nd[] = { yyvsp[-19].yNode, yyvsp[-17].yNode, yyvsp[-15].yNode, yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode,
												  yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-21].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 39:
#line 216 "SelectParser.y"
{ yyval.yNode = yyvsp[-17].yNode;
								  OpNode nd[] = { yyvsp[-15].yNode, yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode,
												  yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-22].yNode, yyvsp[-20].yNode };
								  yyvsp[-17].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 40:
#line 221 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 41:
#line 224 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-1].yNode, yyvsp[-8].yNode, yyvsp[-6].yNode); ;
    break;}
case 42:
#line 227 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode,
																true); ;
    break;}
case 43:
#line 231 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-1].yNode, yyvsp[-8].yNode, yyvsp[-6].yNode,
																true); ;
    break;}
case 44:
#line 235 "SelectParser.y"
{ prependSetName(yyvsp[-3].yFileName);
								  yyval.yNode = GtiFilter::expandGtis(*yyvsp[-3].yFileName, yyvsp[-1].yNode);
								  delete yyvsp[-3].yFileName; ;
    break;}
case 45:
#line 239 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = GtiFilter::expandGtis(*yyvsp[-1].yFileName, yyvsp[-5].yNode);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 46:
#line 243 "SelectParser.y"
{ prependSetName(yyvsp[-5].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-5].yFileName, yyvsp[-3].yNode, yyvsp[-1].yNode);
								  delete yyvsp[-5].yFileName; ;
    break;}
case 47:
#line 247 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-1].yFileName);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 48:
#line 251 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-1].yFileName, yyvsp[-8].yNode, yyvsp[-6].yNode);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 49:
#line 255 "SelectParser.y"
{ prependSetName(yyvsp[-9].yFileName);
								  yyval.yNode = new MaskFilter(*yyvsp[-9].yFileName, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode);
								  delete yyvsp[-9].yFileName; ;
    break;}
case 50:
#line 259 "SelectParser.y"
{ prependSetName(yyvsp[-5].yFileName);
								  yyval.yNode = new MaskFilter(*yyvsp[-5].yFileName, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-12].yNode, yyvsp[-10].yNode);
								  delete yyvsp[-5].yFileName; ;
    break;}
case 51:
#line 262 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode;
								  OpNode nd[] = { yyvsp[-2].yNode };
								  yyvsp[0].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 52:
#line 265 "SelectParser.y"
{ const TableDescriptor *tab =
									selectorGlobals->tableDescriptor;
								  if (tab &&
									  tab->column(yyvsp[-1].yNode->name())->nullDefined())
									  yyval.yNode = new Eq(yyvsp[-1].yNode, new NumericLiteral(DBL(
										  tab->column(yyvsp[-1].yNode->name())->
															nullValue())));
								  else
									  yyval.yNode = new FalseNode; ;
    break;}
case 53:
#line 274 "SelectParser.y"
{ yyval.yNode = new NanOp(yyvsp[-1].yNode); ;
    break;}
case 55:
#line 276 "SelectParser.y"
{ yyvsp[-2].yNode->textLengthMax(32); yyval.yNode = new FalseNode; ;
    break;}
case 56:
#line 277 "SelectParser.y"
{ yyvsp[0].yNode->textLengthMax(32); yyval.yNode = new FalseNode; ;
    break;}
case 57:
#line 278 "SelectParser.y"
{ yyvsp[-2].yNode->textLengthMax(32); yyval.yNode = new FalseNode; ;
    break;}
case 58:
#line 279 "SelectParser.y"
{ yyvsp[0].yNode->textLengthMax(32); yyval.yNode = new FalseNode; ;
    break;}
case 59:
#line 281 "SelectParser.y"
{ yyval.yNode = new ConeFilter(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 60:
#line 283 "SelectParser.y"
{ yyval.yNode = new ConeFilter(yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-7].yNode); ;
    break;}
case 61:
#line 285 "SelectParser.y"
{ yyval.yNode = new Add(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 62:
#line 286 "SelectParser.y"
{ yyval.yNode = new Sub(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 63:
#line 287 "SelectParser.y"
{ yyval.yNode = new Mul(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 64:
#line 288 "SelectParser.y"
{ yyval.yNode = new Div(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 65:
#line 289 "SelectParser.y"
{ yyval.yNode = new Modulo(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 66:
#line 290 "SelectParser.y"
{ yyval.yNode = new Expo(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 67:
#line 291 "SelectParser.y"
{ yyval.yNode = new And(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 68:
#line 292 "SelectParser.y"
{ yyval.yNode = new Or(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 69:
#line 293 "SelectParser.y"
{ yyval.yNode = new Xor(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 70:
#line 294 "SelectParser.y"
{ yyval.yNode = new Lshift(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 71:
#line 295 "SelectParser.y"
{ yyval.yNode = new Rshift(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 72:
#line 296 "SelectParser.y"
{ yyval.yNode = new Bitcompl(yyvsp[0].yNode); ;
    break;}
case 73:
#line 297 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 74:
#line 301 "SelectParser.y"
{ yyval.yNode = yyvsp[-5].yNode;
								  OpNode nd[] = { yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-5].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 75:
#line 304 "SelectParser.y"
{ yyval.yNode = new Uminus(yyvsp[0].yNode); ;
    break;}
case 76:
#line 305 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 77:
#line 308 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 78:
#line 309 "SelectParser.y"
{ yyval.yNode = new VectorComponent(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 79:
#line 310 "SelectParser.y"
{ yyval.yNode = new ScalarProduct(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 80:
#line 311 "SelectParser.y"
{ yyval.yNode = new VectorNorm(yyvsp[-1].yNode); ;
    break;}
case 84:
#line 316 "SelectParser.y"
{ yyval.yNode = new VectorAdd(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 85:
#line 317 "SelectParser.y"
{ yyval.yNode = new VectorSub(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 86:
#line 318 "SelectParser.y"
{ yyval.yNode = new VectorScalarMult(yyvsp[0].yNode, yyvsp[-2].yNode); ;
    break;}
case 87:
#line 319 "SelectParser.y"
{ yyval.yNode = new VectorScalarMult(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 88:
#line 320 "SelectParser.y"
{ yyval.yNode = new VectorScalarDiv(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 89:
#line 322 "SelectParser.y"
{ yyval.yNode = new CrossProd(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 90:
#line 323 "SelectParser.y"
{ yyval.yNode = new VectorMinus(yyvsp[0].yNode); ;
    break;}
case 91:
#line 325 "SelectParser.y"
{ yyval.yNode = new UnitVector(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 92:
#line 327 "SelectParser.y"
{ yyval.yNode = new SkyVector(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 93:
#line 329 "SelectParser.y"
{ yyval.yNode = new Vector(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 94:
#line 331 "SelectParser.y"
{ yyval.yNode = new StrRange(false, false); ;
    break;}
case 95:
#line 332 "SelectParser.y"
{ yyval.yNode = new StrRange(true, false, yyvsp[-2].yNode); ;
    break;}
case 96:
#line 333 "SelectParser.y"
{ yyval.yNode = new StrRange(false, true, yyvsp[-1].yNode); ;
    break;}
case 97:
#line 334 "SelectParser.y"
{ yyval.yNode = new StrRange(true, true, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 98:
#line 336 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  yyvsp[-3].yNode->textLengthMax(yyvsp[-1].yNode->textLength());
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 99:
#line 340 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[0].yNode->textLengthMax(yyvsp[-1].yNode->textLength());
								  /* register text as 3rd child */
								  yyvsp[0].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 100:
#line 345 "SelectParser.y"
{ yyval.yNode = new StrConcat(yyvsp[-2].yNode, yyvsp[0].yNode);
								  yyval.yNode->textLengthMax(yyvsp[-2].yNode->textLength() +
													yyvsp[0].yNode->textLength()); ;
    break;}
case 101:
#line 348 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 104:
#line 353 "SelectParser.y"
{ yyval.yNode = yyvsp[-4].yNode;
								  yyvsp[-4].yNode->addPoint(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 105:
#line 355 "SelectParser.y"
{ yyval.yNode = new NodePointList;
								  yyval.yNode->addPoint(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 106:
#line 359 "SelectParser.y"
{ yyval.yNode = yyvsp[-2].yNode;
								  OpNode nd[] = { yyvsp[0].yNode };
								  yyvsp[-2].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 107:
#line 362 "SelectParser.y"
{ yyval.yNode = new InInterval;
								  OpNode nd[] = { yyvsp[0].yNode };
								  yyval.yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 108:
#line 366 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 109:
#line 367 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 110:
#line 368 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 111:
#line 369 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 112:
#line 370 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 113:
#line 371 "SelectParser.y"
{ yyval.yNode = new IntEq(yyvsp[0].yNode); ;
    break;}
case 114:
#line 372 "SelectParser.y"
{ yyval.yNode = new IntEq(yyvsp[-1].yNode); ;
    break;}
case 115:
#line 373 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-1].yNode); ;
    break;}
case 116:
#line 374 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-2].yNode); ;
    break;}
case 117:
#line 375 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-2].yNode); ;
    break;}
case 118:
#line 376 "SelectParser.y"
{ yyval.yNode = new IntLt(yyvsp[-2].yNode); ;
    break;}
case 119:
#line 377 "SelectParser.y"
{ yyval.yNode = new IntLt(yyvsp[-2].yNode); ;
    break;}
case 120:
#line 378 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[0].yNode); ;
    break;}
case 121:
#line 379 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[-1].yNode); ;
    break;}
case 122:
#line 380 "SelectParser.y"
{ yyval.yNode = new IntGt(yyvsp[-1].yNode); ;
    break;}
case 123:
#line 381 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[-1].yNode); ;
    break;}
case 124:
#line 382 "SelectParser.y"
{ yyval.yNode = new IntGt(yyvsp[-1].yNode); ;
    break;}
case 125:
#line 383 "SelectParser.y"
{ yyval.yNode = new IntCC(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 126:
#line 384 "SelectParser.y"
{ yyval.yNode = new IntCC(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 127:
#line 385 "SelectParser.y"
{ yyval.yNode = new IntOC(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 128:
#line 386 "SelectParser.y"
{ yyval.yNode = new IntCO(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 129:
#line 387 "SelectParser.y"
{ yyval.yNode = new IntOO(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ((char*)"parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror((char*)"parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 389 "SelectParser.y"


}
