//
//	ascregiontest: test the ASCregion class
//
//	UL, Wed Apr  1 11:23:29 MET DST 1998
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/selectlib/test/faceregion.cc,v 1.5 2001/08/07 14:08:45 ulammers Exp $
//

#include <cassert>
#include <string>
#include <iostream>
#include "SelectUtils.h"

int main()
{
	OutASCregionTable	outtable("faceregion.ds");
	GeoRegion				r;

	Component c[13];

	//	face
	FElliptAnnulus	face(FPoint(256, 230), 155, 115, 165, 120, 90., 90.);
	c[0].push_back(&face);

	//	ears
	FSector	earrs(FPoint(376, 260), -45., 45.),
			earls(FPoint(140, 260), 135., 225.);
	FCircle earrc(FPoint(376, 260), 70),
			earlc(FPoint(140, 260), 70);
	c[1].push_back(&earrs); c[1].push_back(&earrc);
	c[2].push_back(&earls); c[2].push_back(&earlc);

	//	nose
	FEllipse nose(FPoint(256, 230), 40, 20, 90.);
	c[3].push_back(&nose);

	//	eyes
	FAnnulus leftEye(FPoint(306, 320), 8, 25),
			 rightEye(FPoint(206, 320), 8, 25);
	c[4].push_back(&leftEye);
	c[5].push_back(&rightEye);

	//	mouth
	FElliptAnnulus	mouth(FPoint(256, 125), 50, 25, 70, 35, 0., 0.);
	c[6].push_back(&mouth);

	//	teeth
	FRectangle t1(FPoint(245, 100), FPoint(260, 125)),
			   t2(FPoint(216, 120), FPoint(230, 150)),
			   t3(FPoint(278, 120), FPoint(296, 150));
	c[7].push_back(&t1);
	c[8].push_back(&t2);
	c[9].push_back(&t3);

	//	hair
	FRotRectangle h1(FPoint(180, 360), FPoint(195, 460), 45.),
				  h2(FPoint(256, 400), FPoint(266, 500), 0.),
				  h3(FPoint(330, 360), FPoint(345, 460), -45.);
	c[10].push_back(&h1);
	c[11].push_back(&h2);
	c[12].push_back(&h3);

	for (unsigned n=0; n<sizeof(c)/sizeof(c[0]); ++n)
		r.push_back(c[n]);

	outtable << r;

	return 0;
} // main

